//******************************************************************************************************************
// CW_Keyboard.ino - v1.0 - 4/17/2020 G. Thomas, W5JDX -  This code is released to the public domain.
//                             www.amateurlogic.tv
//                             www.twit.tv/shows/ham-nation
// Send Morse Code using a keyboard from a serial terminal
// Note: Limited to 64 characters per transmission.
// This sketch requires the file Codes.ino to function.
//******************************************************************************************************************

int speakerPin = 12;                        //gpio pin for speaker connection, other speaker wire goes to ground
//you should pad this audio for mic input or mixer use
int tonePitch = 800;                        //frequency of cw tone(Hz)

int dotLength = 120;                        //length of dot(ms).
int dashLength = 360;                       //length of dash(ms)
int characterSpace = dashLength;            //character spacing delay

void setup() {                  //------------- setup function runs when Arduino starts up -----------------
  pinMode(speakerPin, OUTPUT);              //sets the speaker gpio pin as output

  Serial.begin(9600);                       //open the serial port at 9600 baud
  Serial.println("CW_Keyboard - v1.0 - 2020 G. Thomas, W5JDX");
}

void loop() {                   //------------- loop function runs over and over continuously -----------------
  noTone(speakerPin);                       //turn off tone function for speakerPin
  if (Serial.available() > 0) {             //are characters waiting to be read?
    char inChar = Serial.read();            //read incoming serial data into char variable, one character at a time
    String chrString = String(inChar);      //copy char variable into a string so we can convert to upper case easily
    chrString.toUpperCase();                //convert character to upper case
    SendCharacter(chrString);               //call function in Codes.ino to decode and send morse code symbols
  }
}
