//******************************************************************************************************************
// Codes.ino - v1.0 - 4/17/2020 G. Thomas, W5JDX -  This code is released to the public domain.
//                       www.amateurlogic.tv
//                       www.twit.tv/shows/ham-nation
// Codes and Functions for sending Morse Code. Used with CW_Keyboard.ino project.
//******************************************************************************************************************

void dot() //------------- Function to send a dot character -----------------
{
  tone(speakerPin, tonePitch, dotLength);   //play tone for dot
  Serial.print(".");                        //print dit to screen
  delay(dotLength);                         //delay for tone length (time to play tone)
  delay(10);                                //delay for additional spacing
}

void dash() //------------- Function to send a dash character -----------------
{
  tone(speakerPin, tonePitch, dashLength);  //play tone for dash
  Serial.print("-");                        //print dah to screen
  delay(dashLength);                        //delay for tone length (time to play tone)
  delay(10);                                //delay for additional spacing
}

void SendCharacter(String character) {     //------------- Function to Determine character's code symbols and call dot and dash functions -----------------
  Serial.println();                         //move cursor to new line
  Serial.print(character + "  ");          //print the character + a space to screen
  char asciichar[2];                       //create a char array variable to hold character + Ascii 0 string terminator
  character.toCharArray(asciichar, 2);     //copy string character to char array asciichar
  switch (asciichar[0]) {                  //select the ascii character code in position 1 of the asciichar array
    case 65:                               //ascii code 65 = A
      dot(); dash();                                    // A  call functions for morse code symbols dot and dash (A)
      break;
    case 66:
      dash(); dot(); dot(); dot();                      // B
      break;
    case 67:
      dash(); dot(); dash(); dot();                     // C
      break;
    case 68:
      dash(); dot(); dot();                             // D
      break;
    case 69:
      dot();                                            // E
      break;
    case 70:
      dot(); dot(); dash(); dot();                      // F
      break;
    case 71:
      dash(); dash(); dot();                            // G
      break;
    case 72:
      dot(); dot(); dot(); dot();                       // H
      break;
    case 73:
      dot(); dot();                                     // I
      break;
    case 74:
      dot(); dash(); dash(); dash();                    // J
      break;
    case 75:
      dash(); dot(); dash();                            // K
      break;
    case 76:
      dot(); dash(); dot(); dot();                      // L
      break;
    case 77:
      dash(); dash();                                   // M
      break;
    case 78:
      dash(); dot();                                    // N
      break;
    case 79:
      dash(); dash(); dash();                           // O
      break;
    case 80:
      dot(); dash(); dash(); dot();                     // P
      break;
    case 81:
      dash(); dash(); dot(); dash();                    // Q
      break;
    case 82:
      dot(); dash(); dot();                             // R
      break;
    case 83:
      dot(); dot(); dot();                              // S
      break;
    case 84:
      dash();                                           // T
      break;
    case 85:
      dot(); dot(); dash();                             // U
      break;
    case 86:
      dot(); dot(); dot(); dash();                      // V
      break;
    case 87:
      dot(); dash(); dash();                            // W
      break;
    case 88:
      dash(); dot(); dot(); dash();                     // X
      break;
    case 89:
      dash(); dot(); dash(); dash();                    // Y
      break;
    case 90:
      dash(); dash(); dot(); dot();                     // Z
      break;
    case 48:
      dash(); dash(); dash(); dash(); dash();           // 0
      break;
    case 49:
      dot(); dash(); dash(); dash(); dash();            // 1
      break;
    case 50:
      dot(); dot(); dash(); dash(); dash();             // 2
      break;
    case 51:
      dot(); dot(); dot(); dash(); dash();              // 3
      break;
    case 52:
      dot(); dot(); dot(); dot(); dash();               // 4
      break;
    case 53:
      dot(); dot(); dot(); dot(); dot();                // 5
      break;
    case 54:
      dash(); dot(); dot(); dot(); dot();               // 6
      break;
    case 55:
      dash(); dash(); dot(); dot(); dot();              // 7
      break;
    case 56:
      dash(); dash(); dash(); dot(); dot();             // 8
      break;
    case 57:
      dash(); dash(); dash(); dash(); dot();            // 9
      break;
    case 64:
      dot(); dash(); dash(); dot(); dash();  dot();     // @
      break;
    case 46:
      dot(); dash(); dot(); dash(); dot(); dash();      // .
      break;
    case 44:
      dash(); dash(); dot(); dot(); dash(); dash();     // ,
      break;
    case 63:
      dot(); dot(); dash(); dash(); dot(); dot();       // ?
      break;
    case 45:
      dash(); dot(); dot(); dot(); dot(); dash();       // -
      break;
    case 61:
      dash(); dot(); dot(); dot(); dash();              // =
      break;
    case 58:
      dash(); dash(); dash(); dot(); dot(); dot();      // :
      break;
    case 59:
      dash(); dot(); dash(); dot(); dash(); dot();      // ;
      break;
    case 40:
      dash(); dot(); dash(); dash(); dot();             // (
      break;
    case 41:
      dash(); dot(); dash(); dash(); dot(); dash();     // )
      break;
    case 47:
      dash(); dot(); dot(); dash(); dot();              // /
      break;
    case 34:
      dot(); dash(); dot(); dot(); dash(); dot();       // "
      break;
    case 36:
      dot(); dot(); dot(); dash(); dot(); dot(); dash();// $
      break;
    case 39:
      dot(); dash(); dash(); dash(); dash(); dot();     // '
      break;
    case 95:
      dot(); dot(); dash(); dash(); dot(); dash();      // _
      break;
    case 43:
      dot(); dash(); dot(); dash(); dot();              // +
      break;
  }
  delay(characterSpace);                  //character completed. delay for character spacing
}
